/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

var feeds = null;
var busy = null;
var feedsTab = null;
var aboutTab = null;
var reloadTab = null;

var loadFeeds = null;
var beforeInitEnv = null;
var inTrans = false;
	
var WORKLIGHT_URL = 'https://www.ibm.com/developerworks/mobile/';

function wlCommonInit(){
	
	WL.Logger.debug("Start wlCommonInit");
	
	busy = new WL.BusyIndicator('content');
	
	require([
				"dojo/_base/lang",
				"dojo/_base/array",
				"dojo/dom",
				"dojo/dom-class",
				"dojo/dom-construct",
				"dojo/query",
				"dojo/dom-style",
				"dojo/dom-attr",
				"dojo/on",
				"dojo/_base/Deferred",
				"dijit/registry",
				"dojo/has",
				"dojo/ready",
				"dojox/mobile/parser",
				"dojox/mobile",
				"dojox/mobile/compat",
				 "dojox/mobile/deviceTheme",
				 "dojox/mobile/View",
				 "dojox/mobile/ScrollableView",
				 "dojox/mobile/TabBar",
				 "dojox/mobile/TabBarButton",
				 ],
	         
			function(lang,array,dom,domClass,domConstruct,query,domStyle,domAttr,on,Deferred,registry,has, ready)
			{
		
				loadFeeds = function(){
					
					WL.Logger.debug("Invoke loadFeeds");
					
					busy.show();
	
					var invocationData = {
							adapter: "WorklightStarterAdapter",
							procedure: "getEngadgetFeeds",
							parameters: [true]
					};
					
					WL.Client.invokeProcedure(invocationData, {
						onSuccess: lang.hitch(this, loadFeedsOK), 
						onFailure: lang.hitch(this, loadFeedsFAIL)
					}); 
				}
				
				loadFeedsOK = function(data){
					
					WL.Logger.debug("Start loadFeedsOK");
					if (!data || !data.invocationResult || !data.invocationResult.items || data.invocationResult.items.length==0)
						console.debug("Could not retrieve feeds");
					feeds = data.invocationResult.items;
	      			
	      			//Clean existing list
	      			var feedInfo = dom.byId("feedList");		
	      			var widgets = registry.findWidgets(feedInfo);
	      			array.forEach(widgets, function(w) {
	      				w.destroyRecursive(true);
	      			});
	      			domConstruct.empty(feedInfo); 
	      			
	//				feeds = [
	//				         {
	//				             "description": "<p>\n\t<a href=\"http://www.engadget.com/2011/10/12/mit-researchers-suggest-graphene-could-be-used-to-build-a-better/\"><img src=\"images/feedimages/graphene-camera-sensors.jpg\" style=\"border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-top-style: solid; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; margin-left: 12px; margin-right: 12px; margin-top: 16px; margin-bottom: 16px; float: right; \" /><\/a>As you may have noticed from the pace of research over the past few years, <a href=\"http://www.engadget.com/tag/graphene\">graphene<\/a> is promising to make a whole lot of things a whole lot better. Now, it seems, you can also add camera sensors to the list. A team of MIT researchers recently discovered that graphene can serve as a photodetector over a \"very wide energy range,\" and that it works particularly well in infrared light, where other types of detectors often come up short. That, the researchers say, could open to the door to everything from better nightvision systems to more advanced detectors for astronomical telescopes -- not to mention more inexpensive camera sensors in general, since graphene is cheap to work with. What's more, the researchers also suggest that those same light-detecting abilities could make graphene a good material for collecting solar energy, although they note that there's still much more research needed to determine if it's truly an efficient means of generating energy.<\/p><p style=\"padding:5px;background:#ddd;border:1px solid #ccc;clear:both;\"><a href=\"http://www.engadget.com/2011/10/12/mit-researchers-suggest-graphene-could-be-used-to-build-a-better/\">MIT researchers suggest graphene could be used to build a better camera sensor<\/a> originally appeared on <a href=\"http://www.engadget.com\">Engadget<\/a> on Wed, 12 Oct 2011 03:35:00 EDT.  Please see our <a href=\"http://www.weblogsinc.com/feed-terms/\">terms for use of feeds<\/a>.<\/p><h6 style=\"clear: both; padding: 8px 0 0 0; height: 2px; font-size: 1px; border: 0; margin: 0; padding: 0;\"><\/h6><a href=\"http://www.engadget.com/2011/10/12/mit-researchers-suggest-graphene-could-be-used-to-build-a-better/\" rel=\"bookmark\" title=\"Permanent link to this entry\">Permalink<\/a> <img class=\"img_label\" src=\"images/post_label_VIA.gif\" alt=\"\"/><span class=\"caption\"><a href=\"http://www.wired.com/gadgetlab/2011/10/atom-thick-graphene-sheets-could-make-great-camera-sensors/?utm_source=feedburner&utm_medium=feed&utm_campaign=Feed%3A+GearFactor+%28Blog+-+Gadget+Lab+%28Gear+Factor%29%29\">Wired Gadget Lab<\/a><!--//--><\/span>  |  <img class=\"img_label\" src=\"images/post_label_source.gif\" alt=\"source\"/><span class=\"caption\"><a href=\"http://www.mit.edu/newsoffice/2011/graphene-thermoelectric-1007.html\">MIT News<\/a><!--//--><\/span>  | <a href=\"http://www.engadget.com/forward/20079155/\" title=\"Send this entry to a friend via email\">Email this<\/a> | <a href=\"http://www.engadget.com/2011/10/12/mit-researchers-suggest-graphene-could-be-used-to-build-a-better/#comments\" title=\"View reader comments on this entry\">Comments<\/a>",
	//				             "link": "http://www.engadget.com/2011/10/12/mit-researchers-suggest-graphene-could-be-used-to-build-a-better/",
	//				             "pubDate": "Wed, 12 Oct 2011 03:35:00 EDT",
	//				             "title": "MIT researchers suggest graphene could be used to build a better camera sensor"
	//				           },
	//				           {
	//				             "description": "<div style=\"text-align: center;\">\n\t<img border=\"1\" hspace=\"4\" src=\"images/feedimages/icloudsssite.jpg\" vspace=\"4\" /><\/div>\nDesktop or mobile access to Apple's <a href=\"http://www.engadget.com/tag/icloud\">iCloud<\/a> will still require the absolute latest versions of <a href=\"http://www.engadget.com/2011/07/25/mac-os-x-lion-10-7-2-beta-brings-icloud-support-no-bug-fixes/\">OS X Lion<\/a> and <a href=\"http://www.engadget.com/wwdc-2011/apple-ios-5-hands-on-preview/\">iOS 5<\/a> that haven't been officially released just yet, but you can get into the website right now. Line jumpers may have noticed the site opened up to all a few hours ago, and now the design has changed, dropping the beta tag for this more inviting storefront. Hit the source link below to check it out for yourself (we've <a href=\"http://www.engadget.com/2011/08/02/apple-icloud-and-iwork-beta-for-ios-hands-on/\">got the full breakdown here<\/a>), but have your Apple ID and password handy.<br />\n<br />\n[Thanks to everyone who sent this in]<p style=\"padding:5px;background:#ddd;border:1px solid #ccc;clear:both;\"><a href=\"http://www.engadget.com/2011/10/12/icloud-opens-to-the-masses-ios-5-lurks-near/\">iCloud opens to the masses, iOS 5 lurks near<\/a> originally appeared on <a href=\"http://www.engadget.com\">Engadget<\/a> on Wed, 12 Oct 2011 02:29:00 EDT.  Please see our <a href=\"http://www.weblogsinc.com/feed-terms/\">terms for use of feeds<\/a>.<\/p><h6 style=\"clear: both; padding: 8px 0 0 0; height: 2px; font-size: 1px; border: 0; margin: 0; padding: 0;\"><\/h6><a href=\"http://www.engadget.com/2011/10/12/icloud-opens-to-the-masses-ios-5-lurks-near/\" rel=\"bookmark\" title=\"Permanent link to this entry\">Permalink<\/a>   |    | <a href=\"http://www.engadget.com/forward/20079473/\" title=\"Send this entry to a friend via email\">Email this<\/a> | <a href=\"http://www.engadget.com/2011/10/12/icloud-opens-to-the-masses-ios-5-lurks-near/#comments\" title=\"View reader comments on this entry\">Comments<\/a>",
	//				             "link": "http://www.engadget.com/2011/10/12/icloud-opens-to-the-masses-ios-5-lurks-near/",
	//				             "pubDate": "Wed, 12 Oct 2011 02:29:00 EDT",
	//				             "title": "iCloud opens to the masses, iOS 5 lurks near"
	//				           }
	//				           ];
					
					var feedList = registry.byId("feedList");
					
					array.forEach(feeds, lang.hitch(this, function(feed,i) {
						
						var itemHtml = domConstruct.create("div", {innerHTML:
							"<div class='feedTitle' index='" + i + "'>" + feed.title + "</div><div class='pubDate'>"+ feed.pubDate+"</div>"
						});
						
						var itemCfg = {icon:""};
						itemCfg["class"] = "mblVariableHeight";
						itemCfg.noArrow = false;
						itemCfg.moveTo = "#";
//						itemCfg.rightIcon = "mblDomButtonBlueCircleArrow";
						
						var thisObj = this;
						itemCfg.onClick = function(e){
							feedList.selectItem(this);
							lang.hitch(this,thisObj.displayFeed)(i);
						};
						
						var item = new dojox.mobile.ListItem(itemCfg, itemHtml);
						//Connect event
//						on(item.domNode,"click",lang.hitch(this,this.displayFeed));
						feedList.addChild(item); 
						
					}), this);
					
	      			busy.hide();
				}
				
				loadFeedsFAIL = function(){ busy.hide(); }
				
				displayFeed = function(index) {
					
//					var q = query("div[index]",evt.currentTarget);
//					console.log("Query: "+q);
//					var selectedIndex = domAttr.get(q[0],"index");
					
					var feedDetail = feeds[index].description;
					dom.byId("feedDetail").innerHTML = feedDetail;
					
					//Refine img and links
					query("img").forEach(function(node, index, nodelist){
						if(domAttr.get(node, "src").indexOf("jpg")>=0){
							if(node.style.width && node.style.height){
								var rate = parseInt(node.style.height.replace(/px/gi,""))/parseInt(node.style.width.replace(/px/gi,"")); 
								node.style.width = document.body.clientWidth/1.8 + "px";
								node.style.height = (document.body.clientWidth/1.8) * rate + "px";
								domAttr.set(node, "width",260);
							}else{
								node.style.width = node.style.height = document.body.clientWidth/1.8 + "px";
								domAttr.set(node, "width",260);
							}
						}
					});
					
					query("#feedDetail a").forEach(function(node, index, nodelist){
							domAttr.set(node, "target","_blank");
					});
					
					if(!inTrans){
						inTrans = true;
						registry.byId("mainFeedView").performTransition("FeedDeatilView",1,"slide");
					}
					
					registry.byId("homeMenuItem").selected = false;
				}
				
				loadAbout = function(){
					var content = '<h2 id="aboutWorklightTitle">IBM Worklight</h2><p id="aboutWorklightProductName">IBM Worklight</p><p id="aboutWorklightVersion">Version 5.0</p>' + 
						'<p id="aboutWorklightText">Licensed Materials - Property of IBM 5725-G92 &copy; Copyright IBM Corp. 2006, 2013. All Rights Reserved. US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.</p><a id="aboutWorklightLink">IBM Worklight</a>';
					
					dom.byId("aboutTab").innerHTML = content;
					on(dom.byId('aboutWorklightLink'), "touchstart", function() {
						WL.App.openURL(WORKLIGHT_URL, '_blank');
					});
				}
				
				ready(function()
				{
					WL.Logger.debug("Everything loaded");
					
					//on(registry.byId("reloadButton"),"click",lang.hitch(this,this.loadFeeds));
					//loadFeedsOK();
					//loadAbout();
					
					setTimeout(function() {
						domStyle.set('loadDiv', 'display', 'none');
						
						beforeInitEnv();
						
						WL.Logger.debug("About to call LoadFeeds");
						loadFeeds();
						loadAbout();
					}, 1000);
				}
			);
	});
	

}
